# coding: utf-8

"""
    MailSlurp API

    MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It's designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository  # noqa: E501

    The version of the OpenAPI document: 6.5.2
    Contact: contact@mailslurp.dev
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mailslurp_client.configuration import Configuration


class UpdateSmtpAccessOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'smtp_username': 'str',
        'smtp_password': 'str'
    }

    attribute_map = {
        'smtp_username': 'smtpUsername',
        'smtp_password': 'smtpPassword'
    }

    def __init__(self, smtp_username=None, smtp_password=None, local_vars_configuration=None):  # noqa: E501
        """UpdateSmtpAccessOptions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._smtp_username = None
        self._smtp_password = None
        self.discriminator = None

        self.smtp_username = smtp_username
        self.smtp_password = smtp_password

    @property
    def smtp_username(self):
        """Gets the smtp_username of this UpdateSmtpAccessOptions.  # noqa: E501

        SMTP username for login  # noqa: E501

        :return: The smtp_username of this UpdateSmtpAccessOptions.  # noqa: E501
        :rtype: str
        """
        return self._smtp_username

    @smtp_username.setter
    def smtp_username(self, smtp_username):
        """Sets the smtp_username of this UpdateSmtpAccessOptions.

        SMTP username for login  # noqa: E501

        :param smtp_username: The smtp_username of this UpdateSmtpAccessOptions.  # noqa: E501
        :type: str
        """

        self._smtp_username = smtp_username

    @property
    def smtp_password(self):
        """Gets the smtp_password of this UpdateSmtpAccessOptions.  # noqa: E501

        SMTP password for login  # noqa: E501

        :return: The smtp_password of this UpdateSmtpAccessOptions.  # noqa: E501
        :rtype: str
        """
        return self._smtp_password

    @smtp_password.setter
    def smtp_password(self, smtp_password):
        """Sets the smtp_password of this UpdateSmtpAccessOptions.

        SMTP password for login  # noqa: E501

        :param smtp_password: The smtp_password of this UpdateSmtpAccessOptions.  # noqa: E501
        :type: str
        """

        self._smtp_password = smtp_password

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateSmtpAccessOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateSmtpAccessOptions):
            return True

        return self.to_dict() != other.to_dict()
